SystemOrganization addCategory: #'Magritte-Json'!

!MAElementDescription methodsFor: '*Magritte-Json' stamp: 'pmm 3/23/2011 10:26'!
defaultJsonName
	"Answer the default JSON element name."

	^ self accessor selector greaseString capitalized! !

!MAElementDescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 19:53'!
jsonName
	"Answer the JSON element name."

	^ self propertyAt: #jsonName ifAbsent: [ self defaultJsonName ]! !

!MAElementDescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 19:52'!
jsonName: aString
	self propertyAt: #jsonName put: aString! !

!MADescription class methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 09:34'!
defaultJsonReader
	^ MJJsonReader! !

!MADescription class methodsFor: '*Magritte-Json' stamp: 'pmm 9/3/2009 11:47'!
defaultJsonSerialized
	^self defaultVisible! !

!MADescription class methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 09:35'!
defaultJsonWriter
	^ MJJsonWriter! !

!MADescription methodsFor: '*Magritte-Json' stamp: 'NickAger 1/31/2012 14:18'!
descriptionJsonReader
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #jsonReader;
		label: 'JSON Reader';
		priority: 320;
		default: self class defaultJsonReader;
		options: self class defaultJsonReader withAllSubclasses;
		reference: MAClassDescription new;
		yourself! !

!MADescription methodsFor: '*Magritte-Json' stamp: 'pmm 9/3/2009 11:46'!
isJsonSerialized
	"Answer whether the described object should be serialized to JSON."

	^ self propertyAt: #jsonSerialized ifAbsent: [ self class defaultJsonSerialized ]! !

!MADescription methodsFor: '*Magritte-Json' stamp: 'pmm 9/3/2009 11:45'!
isJsonSerialized: aBoolean

	^ self propertyAt: #jsonSerialized put: aBoolean! !

!MADescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 09:36'!
jsonReader
	"Answer a Visitor that can be used to parse the model described by the receiver from a JSON string."

	^ self propertyAt: #jsonReader ifAbsent: [ self class defaultJsonReader ]! !

!MADescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 09:36'!
jsonReader: aClass
	self propertyAt: #jsonReader put: aClass! !

!MADescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 09:37'!
jsonWriter
	"Answer a Visitor that can be used to convert the model described by the receiver to a JSON string."

	^ self propertyAt: #jsonWriter ifAbsent: [ self class defaultJsonWriter ]! !

!MADescription methodsFor: '*Magritte-Json' stamp: 'pmm 8/31/2009 09:37'!
jsonWriter: aClass
	"Answer a Visitor that can be used to convert the model described by the receiver to a JSON string."

	self propertyAt: #jsonWriter put: aClass! !

JSJsonParser subclass: #MJJsonParser
	instanceVariableNames: 'description object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Json'!

!MJJsonParser class methodsFor: 'instance creation' stamp: 'NickAger 2/3/2012 16:08'!
onStream: aStream for: anObject
	^ self basicNew initializeOnStream: aStream for: anObject! !

!MJJsonParser class methodsFor: 'instance creation' stamp: 'NickAger 2/3/2012 16:07'!
parse: aString for: anObject
	^ (self onStream: aString readStream for: anObject) parse! !

!MJJsonParser methodsFor: 'adding' stamp: 'NickAger 1/31/2012 11:52'!
addProperty: anAssociation to: anObject
	| child value |
	child := self descriptionFor: anAssociation key of: anObject magritteDescription.
	value := anAssociation value.
	value isString ifTrue: [
		value := child jsonReader read: value readStream description: child ].
	anObject write: value using: child.
	^ anObject! !

!MJJsonParser methodsFor: 'creating' stamp: 'JohnMcKeon 6/23/2012 13:26'!
createArray
	^OrderedCollection new! !

!MJJsonParser methodsFor: 'creating' stamp: 'JohnMcKeon 6/23/2012 10:46'!
createObject
	^ object ifNil: [ object := description kind new ]! !

!MJJsonParser methodsFor: 'private' stamp: 'pmm 9/10/2009 16:16'!
descriptionFor: aString of: aDescriptionContainer
	^ aDescriptionContainer detect: [ :each |
		each jsonName = aString ]! !

!MJJsonParser methodsFor: 'initialize-release' stamp: 'NickAger 3/7/2012 09:39'!
initializeOnStream: aStream for: anObject
	self initializeOn: aStream.
	object := anObject.
	description := anObject magritteDescription! !

!MJJsonParser methodsFor: 'private' stamp: 'JohnMcKeon 6/23/2012 13:36'!
objectFor: aDescription
	(aDescription isKindOf: MAToManyRelationDescription)
		ifFalse: [ ^aDescription kind new ].
	^aDescription classes first new! !

!MJJsonParser methodsFor: 'parsing-internal' stamp: 'JohnMcKeon 6/23/2012 12:45'!
parseProperty
	| name value newDescription |
	name := self parseString.
	self expect: ':'.
	newDescription := self descriptionFor: name of: description.
	(newDescription isKindOf: MARelationDescription)
		ifTrue: [
			self
				pushObject: newDescription
				during: [ value := (newDescription isKindOf: MAToOneRelationDescription)
					ifTrue: [ self parseObject ]
					ifFalse: [ self parseArray ] ] ]
		ifFalse: [
			self
				pushDescription: newDescription
				during: [ value := self parseValue ]].
	^ self createProperty: name with: value.! !

!MJJsonParser methodsFor: 'accessing' stamp: 'pmm 9/10/2009 16:29'!
pushDescription: aDescription during: aBlock
	| old |
	old := description.
	description := aDescription.
	aBlock value.
	description := old.! !

!MJJsonParser methodsFor: 'accessing' stamp: 'JohnMcKeon 6/23/2012 11:00'!
pushObject: aDescription during: aBlock
	| old desc |
	old := object.
	desc := description.
	description := aDescription reference.
	object := self objectFor: aDescription.
	aBlock value.
	object := old.
	description := desc! !

WAObject subclass: #MJObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Json'!

!MJObject commentStamp: 'pmm 9/2/2009 14:46' prior: 0!
A MJObject is a common base class that provides some convenience methods for JSON/Smalltalk mapping.
!

!MJObject methodsFor: 'accessing-description' stamp: 'NickAger 1/31/2012 11:55'!
descriptionContainer
	"Return the default description container."

	<magritteContainer>
	^ MAPriorityContainer new
		label: self class label;
		kind: self class;
		yourself! !

!GRObject class methodsFor: '*magritte-json' stamp: 'NickAger 2/3/2012 16:28'!
fromJson: aString
	"deliberately don't call yourself as we want the result from #fromJson:"
	^ self new fromJson: aString
! !

!GRObject methodsFor: '*magritte-json' stamp: 'NickAger 2/3/2012 16:08'!
fromJson: aString
	^ MJJsonParser parse: aString for: self! !

!GRObject methodsFor: '*magritte-json' stamp: 'pmm 2/18/2012 16:55'!
jsonOn: aRenderer
	| description |
	description := self magritteDescription.
	description jsonWriter
		write: self
		description: description
		to: aRenderer! !

MAStringReader subclass: #MJJsonReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Json'!

!MJJsonReader methodsFor: 'visiting-description' stamp: 'pmm 9/1/2009 11:00'!
visitDateAndTimeDescription: aDescription
	self object: (DateAndTime readFrom: self stream)! !

!MJJsonReader methodsFor: 'visiting-description' stamp: 'EstebanLorenzano 8/11/2011 16:12'!
visitDateDescription: aDescription
	self object: (Date readFrom: self stream)! !

MAWriter subclass: #MJJsonWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Json'!

!MJJsonWriter commentStamp: 'NickAger 3/27/2012 14:06' prior: 0!
Magritte Json Writer!

!MJJsonWriter methodsFor: 'private' stamp: 'NickAger 3/27/2012 14:13'!
defaultWriteStream
	^ WriteStream on: String new! !

!MJJsonWriter methodsFor: 'visiting-description' stamp: 'NickAger 3/27/2012 14:13'!
visitContainer: aDescription
	| first |
	first := true.
	stream nextPut: ${.
	aDescription do: [ :each |
		each isJsonSerialized ifTrue: [
			| nextObject |
			nextObject := self object readUsing: each.
			nextObject isNil ifFalse: [
				first
					ifTrue: [ first := false ]
					ifFalse: [ stream nextPut: $, ].
				self writeElementKeyOf: each.
				stream nextPut: $:.
				each jsonWriter
					write: nextObject
					description: each to: stream ] ] ].
	stream nextPut: $}! !

!MJJsonWriter methodsFor: 'visiting-description' stamp: 'pmm 8/31/2009 23:27'!
visitDateAndTimeDescription: aDescription
	self object printString javascriptOn: self stream! !

!MJJsonWriter methodsFor: 'visiting-description' stamp: 'EstebanLorenzano 8/11/2011 16:13'!
visitDateDescription: aDescription
	self object printString javascriptOn: self stream! !

!MJJsonWriter methodsFor: 'visiting-description' stamp: 'NickAger 8/10/2011 07:02'!
visitElementDescription: aDescription
	self object jsonOn: self stream! !

!MJJsonWriter methodsFor: 'private' stamp: 'NickAger 3/27/2012 14:14'!
writeElementKeyOf: aDescription
	
	self stream json: aDescription jsonName! !
